<?php
/* Autoindex directories.
   Copyright (C) 2005, 2006 David Englund.

This file is part of GNU Sovix.

GNU Sovix is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2, or (at your option)
any later version.

GNU Sovix is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with GNU Sovix; see the file COPYING.  If not, write to
the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
Boston, MA 02110-1301, USA.  */

$infopath=$_GET['infopath'];
$sovixpath=$_SERVER['DOCUMENT_ROOT']."/sovix"; $infopath="$infopath"; require_once "$sovixpath/include/header.inc";

$set_walk_dir="walk_dir2";

require "$infopath/autoindex-data.inc";

function walk_dir2($array,$level) {
  $pad = "  ";
  foreach ($array as $name=>$content) {
    //echo str_pad("",$level,$pad,STR_PAD_LEFT);

    $search = array("/", "_", ".php");
    $output_replace  = array(" / ", " ", "");
    $input_replace  = array("/", " ", "");
    $dir=str_replace($_SERVER['DOCUMENT_ROOT'] ."/", "", $content['PATHNAME']);
    $out_dir=str_replace($search, $output_replace, $dir);
    $file=str_replace($_SERVER['DOCUMENT_ROOT'] ."/", "", $content);
    $out_file=str_replace($search, $output_replace, $file);
    $just_file=str_replace($search, $input_replace, $file);
    $just_dir=str_replace($search, $input_replace, $dir);

    if (is_array($content)) {
      /*      echo $dir;*/
      unset($content['PATHNAME']);
      walk_dir2($content,$level+1);
    }
    else {
      $query=$_GET['query'];
      if (!empty($query) && substr_count(strtolower(basename("$just_file")), strtolower($query)) != 0 || !empty($query) && substr_count(strtolower(basename("$just_dir")), strtolower($query)) != 0) echo "<a href=\"/$file\">".str_replace($query, "<span style=\"color:#FF0000;\">$query</span>", $out_file)."</a><br />".count(file($content))." lines, modified ".date ("Y-m-d H:i:s", filemtime($content))."<p></p>";

      /* Count lines in large files
      function countLines($filename) { $lines =
	  0; $fp = fopen($filename, 'r'); while
         (!feof($fp)) { $buffer = fread($fp, 4096);
	  $lines += substr_count($buffer, "\n"); } fclose($fp) }
      */

    }
  }
}

function build_dir2($path,$extensions,$ignore_files,$ignore_subdirectories) {
  $result = array();
  $d = dir($path);
  while(false !== $entry = $d->read()) {	
    if (in_array($entry,$ignore_files)) {
      continue;
    }
    $extpos = strrpos($entry,".");
    $file = substr($entry,0,$extpos);
    $ext = substr($entry,$extpos+1);
    if ($ignore_subdirectories=="n" && is_dir($path."/".$entry)) {
      if (substr($entry,0,1) == ".") {
	continue;
      }
      $res = build_dir2($path."/".$entry,$extensions,$ignore_files,$ignore_subdirectories);
      if (count($res) > 0) {
	$res['PATHNAME'] = $path."/".$entry;
	$result[$entry] = $res;
      }
    } else if (in_array($ext,$extensions)) {
      $result[$entry] = $path."/".$entry;
    }

  }
  ksort($result);
  return $result;
}

?>

<?php site_footer(); ?>
