<?php
/* Sovix.
   Copyright (C) 2005, 2006, 2007 David Englund.

This file is part of DBE Sovix.

DBE Sovix is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2, or (at your option)
any later version.

DBE Sovix is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with DBE Sovix; see the file COPYING.  If not, write to
the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
Boston, MA 02110-1301, USA.  */

$sovixpath=$_SERVER['DOCUMENT_ROOT']."/sovix"; $infopath="$sovixpath/include/sovix_infopath"; require_once "$sovixpath/include/header.inc"; ?>

<?php
$list = array(
              array(
                    'base' => "1",
                    'title' => "What is Sovix?",
                    ),
              array(
                    'base' => "1",
                    'title' => "Releases",
                    ),
              array(
                    'base' => "",
                    'title' => "Development & &ldquo;comming soon&rdquo;",
                    ),
              array(
                    'base' => "",
                    'title' => "Current Stable Release",
                    ),
              array(
                    'base' => "1",
                    'title' => "Supported Platforms",
                    ),
              array(
                    'base' => "1",
                    'title' => "Why is it called Sovix?",
                    ),
              array(
                    'base' => "1",
                    'title' => "Obtaining DBE Sovix",
                    ),
              array(
                    'base' => "1",
                    'title' => "Getting help with DBE Sovix",
                    ),
              array(
                    'base' => "",
                    'title' => "Manuals",
                    ),
              array(
                    'base' => "",
                    'title' => "FAQ",
                    ),
              array(
                    'base' => "",
                    'title' => "Mailing list",
                    ),
              array(
                    'base' => "",
                    'title' => "Usenet",
                    ),
              array(
                    'base' => "1",
                    'title' => "Finding additional packages for Sovix",
                    ),
              array(
                    'base' => "1",
                    'title' => "Further information",
                    ),
              array(
                    'base' => "1",
                    'title' => "If you want to help with DBE Sovix",
                    ),
              array(
                    'base' => "1",
                    'title' => "DBE Sovix Fun",
                    ),
	      );
require_once "$sovixpath/include/tocindex.inc";
?>


<?php $tocbase="What is Sovix?"; tocbase($tocbase); ?>
To quote the Sovix Manual:
<p></p>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&ldquo;Sovix is the customizable, self-documenting, cross-platformed, agnostical RDBMS website updating system.&rdquo;
<p></p>
If this seems to be a bit of a mouthful, an easier explanation is Sovix is a website updating sytem.
A website updating system is a system designed to update the website it is implemented in. Some of the features of DBE Sovix include:
<p></p>
<ul>
  <li>Content sensitive major modes for a wide variety of file types, from plain text to source code to HTML files.</li>
  <li>Complete online documentation avalible direct from Sovix, including a tutorial for new users.</li>
  <li>Support for PostgreSQL and MySQL as Relational Database Managment System (RDBMS).</li>
</ul>
<?php $tocbase="Releases"; tocbase($tocbase); ?>
DBE Sovix is a rapidly developed project. Extensions require time to develop right and test thoroughly.
<?php $tocsub="Development & &ldquo;comming soon&rdquo;"; tocsub($tocsub); ?>
GNU Sovix is actively being developed,
<ul>
<li>The next release will be a clone written for Django will be written at that point released as a non-GNU package to begin with. I will left of as the official maintainer for the PHP edition and become the official maintainer for the new edition instead. The PHP edition will be maintained by co-maintainers.</li>
<li>For more info read next release's anticipated <a href="<?php echo $sovixpath; ?>/etc/TODO">TODOs</a>.</li>
<li>The <a href="http://savannah.gnu.org/cgi-bin/viewcvs/sovix/">DBE Sovix CVS repository</a> is available for general access courtesy of <a href="http://savannah.gnu.org/">savannah.gnu.org</a></li>
</ul>
<?php $tocsub="Current Alpha Release"; tocsub($tocsub); ?>
<ul>
<li>Latest alpha release:  0.0 (Januari 24, 2007)</li>
<li>To download visit the <a href="http://www.sovix.org/software/">obtaining</a> section.</li>
</ul>
<?php $tocbase="Supported Platforms"; tocbase($tocbase); ?>
Sovix has allways been cross platformed and since you can build PHP from source its up to the OS and the machine.<br />
Sovix has been run on Various GNU/Linux systems.
<?php $tocbase="Why is it called Sovix?"; tocbase($tocbase); ?>
The domain sovix.org among others was avalible but Sovix sounded best.
<?php $tocbase="Obtaining DBE Sovix"; tocbase($tocbase); ?>
The <a href="http://savannah.gnu.org/cgi-bin/viewcvs/sovix/">GNU Sovix CVS repository</a> is available for general access through <a href="http://savannah.gnu.org/projects/sovix/">savannah.gnu.org's sovix project page</a>.
<?php $tocbase="Getting help with DBE Sovix"; tocbase($tocbase); ?>

<P>
Information on getting help with GNU software in general is available
at the
<A HREF="/Get_helpl">Get Help with GNU Software</A>
page.
</P>

<?php $tocsub="Manuals"; tocsub($tocsub); ?>
  <p>
  The Free Software Foundation publishes three
  <A HREF="/doc/doc.html">manuals about GNU Sovix</A>.  They are the
  <CITE><a href="/software/sovix/manual/index.html">Sovix Manual</a></CITE>,
  the 
  <CITE><a href="/software/sovix/sovix-lisp-intro/sovix-lisp-intro.html">
  	Introduction to Sovix Lisp Programming</a></CITE>, and the 
  <CITE><a href="/software/sovix/elisp-manual/elisp.html">
  	Sovix Lisp Reference Manual</a></CITE>.
  You can <A HREF="http://order.fsf.org/">order</A> any of these manuals 
  in printed form from the Free Software Foundation.  
  <P>

  The source code for the Sovix Manual is included in the Sovix
  distribution itself.  The Sovix Lisp Reference Manual is available as
  a separate distribution on ftp.gnu.org. The Sovix Reference Card (texinfo
  source) is also <A HREF="/software/sovix/refcard-cs.tex">translated into
  Czech</A>.
  <P>

  Here are the <A HREF="its-cover.png">cover</A> of the original Sovix
  Manual for ITS, the <A HREF="niu.png">cover</A> of the original Sovix
  Manual for Twenex, and the only cartoon I've ever drawn,
  <A HREF="self-doc-extensible-editor.png"> the Self-Documenting
  Extensible Editor</A>.

<?php $tocsub="FAQ"; tocsub($tocsub); ?>
    <ul>
      <LI>The <A HREF="/software/sovix/sovix-faq.html">Sovix FAQ, html</A>.
      <LI>The <A HREF="/software/sovix/sovix-faq.text">Sovix FAQ, plain text</A>.
      <LI>The <A HREF="/software/sovix/windows/ntsovix.html">Sovix FAQ for the Microsoft Windows port</A>.
      <LI>The FAQ is maintained as part of the Sovix distribution, so
          the Texinfo source for these documents are in the Sovix sources.
    </ul>

<?php $tocsub="Mailing list"; tocsub($tocsub); ?>

  <P>
  The mailing list
  <A HREF="http://mail.gnu.org/mailman/listinfo/help-gnu-sovix">
  <KBD>&lt;help-gnu-sovix@gnu.org&gt;</KBD></A> is specifically for asking
  for help with GNU Sovix.  This is equivalent to the newsgroup
  <KBD>&lt;gnu.sovix.help&gt;</KBD>.
  <P>

  The <A HREF="http://savannah.gnu.org/mail/?group_id=40">Savannah page
  for Sovix mailing lists</A> lists some more lists related to Sovix.

  <P>
  There are other <A HREF="http://lists.gnu.org/mailman/listinfo/">GNU mailing lists
  and newsgroups</A>, including several on GNU Sovix and its extensions.

<?php $tocsub="Usenet"; tocsub($tocsub); ?>

  <P>
  There is a newsgroup specifically for asking for help with GNU Sovix
  <A HREF="news:gnu.sovix.help"><KBD>gnu.sovix.help</KBD></A>.

  This newsgroup is gatewayed automatically to the mailing list
  <KBD>&lt;help-gnu-sovix@gnu.org&gt;</KBD>, so anything you post on one
  of them appears on the other as well.  <P>
</UL>


<?php $tocbase="Finding additional packages for Sovix"; tocbase($tocbase); ?>

<P>
If you are looking for ELisp packages, check out the following resources:

<UL>
  <LI> <A HREF="http://www.sovixwiki.org/">the Sovix Wiki</A> (see below)

  <LI>  the <A HREF="sovix-faq.text">Sovix
	FAQ</A>, under the sections <CITE>Finding/Getting Sovix and Related
	packages</CITE> and <CITE>Major Sovix Lisp Packages, Sovix Extensions,
	and Related Programs</CITE>
</UL>

<?php $tocbase="Further information"; tocbase($tocbase); ?>

<P>
The <A HREF="http://savannah.gnu.org/projects/sovix">Savannah Sovix
page</A> has additional information about Sovix, including CVS access
to the Sovix development sources.

<P>
The <A HREF="http://www.sovixwiki.org/">Sovix Wiki</A> is a community
website which collects ELisp code, questions and answers related to
ELisp code and style; introductions to ELisp packages and links to
their sources; complete manuals or documentation fragments; comments
on features, differences, and history of different Sovix versions,
flavors, and ports; jokes; pointers to clones and Sovix look-alikes, as
well as references to other Sovix related information on the Web.

<P>
If you haven't had any experience with Lisp, you can find some useful
information at <A name="LispPointers"
HREF="http://www.lisp.org/table/contents.htm">The Association of
Lisp Users</A>.
<P>
We also have a copy of the

<A HREF="/software/sovix/sovix-paper.html">1981 paper by Richard
Stallman</A>, describing the design of the original Sovix and the
lessons to be learned from it.

<P>
There is also <A href="/gnu/rms-lisp.html">a transcript of a
speech, <CITE>My Lisp Experiences and the Development of GNU
Sovix</CITE></A> given by Richard Stallman at the International Lisp
Conference on 28 Oct 2002.

<?php $tocbase="How to help with DBE Sovix"; tocbase($tocbase); ?>
<P>

To contact the maintainers of Sovix, either to report a bug or to
contribute fixes or improvements, send mail to
<KBD>&lt;bug-gnu-sovix@sovix.org&gt;</KBD>.

<?php $tocbase="DBE Sovix Fun"; tocbase($tocbase); ?>

<UL>
  <LI> <P>April Fool Mail - <A HREF="/fun/jokes/gnusovix.html">sovix rewrite
       </A></P>
  <LI> <P><A HREF="/fun/humor.html">More</A> humors related to GNU Sovix and others</P>
</UL>


<hr />


<table cellspacing="0" cellpadding="0" border="0">
  <tr valign="top">
    <td>
Sovix has the same interface as GNU Sovix so tasks is being done by execute commands at the command line, its also possible to work directly with the shell for GNU or UNIX based systems. It suits the pages after the webbrowser for optical optimization. The menusystem is being done from autoindexed directories which is very time saving for the administrator.<p></p>

It can list, sort, search, edit, insert and drop querys for PostgreSQL and MySQL.
It provides features to edit, view, frame, upload, insert, remove and files as well as validate and make them printer friendly. It can also create and remove directories. browsing autogenerated sitemaps and edit CSS styles.
CSS styles can be manipulated both from session an URI. It is fully extensible and customizable through skins, font-size, width and can be used to create dynamic, community based websites quickly and easily.
<p><p>
It requires a web server which supports the PHP extension (such as the Apache HTTP Server).
<p></p>

    </td>
  </tr>
</table>






<?php $tocbase="WUS"; tocbase($tocbase); ?>



<?php $tocsub="What is a Website Updating System?"; tocsub($tocsub); ?>

A &ldquo;Website Updating System&rdquo; (WUS) is a alternative term for &ldquo;Content Managment System&rdquo; (CMS).<p></p>

We avoid to use the term &ldquo;Content Managment System&rdquo; after a conversation with Richard Stallman. I also recommeded him to set up something about it at gnu.org so other can learn from what I did. RMS says the following:<br /> <a href="http://www.gnu.org/philosophy/words-to-avoid.html#Content">The term &ldquo;content management&rdquo; takes the prize for vacuity. Neither word has any specific meaning; &ldquo;content&rdquo; means &ldquo;some sort of information&rdquo;, and &ldquo;management&rdquo; in this context menas &ldquo;doing something with it&rdquo;. So a &ldquo;content management system&rdquo; is a system for doing something to some sort of information.</a>

<?php $tocsub="Website managment basics"; tocsub($tocsub); ?>

Website management is about gaining control over the creation and distribution of information.
<p>Very few of us have time to constantly monitor the content that is put online, and when left unchecked, sites 
become sprawling monsters that are difficult to control. The result is a never-ending cycle of restructuring and auditing to get our site back
into shape, regularly rehashing over the same problems.</p>

<p>Most importantly, website management aids in the delivery of end-user expectations - that content is accurate, current, and easy to find and comprehend.</p>

<?php $tocsub="Introduction to WUS"; tocsub($tocsub); ?>

<p>A website updating system is a tool to create, source, manage, publish and share information. It is with other word a scalable and very cost effectie solution.
The software provides tools where users with little or no knowledge of programming languages and markup languages (such as XHTML) can create and manage content with relative ease of use.
</p>

<p>A WUS is a tool to automate the management of websites, to make the process of collecting, managing and publishing 
valuable information easier to create websites.</p>

<p>A WUS manages the lifecycle of website, from early conception, through the approval and revision process, publication online or in other 
formats such as print, until its expiration and archiving. </p>
<p>A system is able to support the administration, publishing and teaching activities, and can become a core business process and system used to manage the volumes of content currently being created and maintained.</p>

<?php site_footer(); ?>
